{================================================================
  Editeur de sprites hardwares CPC+ pour CPC+ By Nemo59 (2021)
  v1.0
 ----------------------------------------------------------------}
Program TPSprite;

{$i UAsic}     { Gestion de l'ASIC CPC+ }
{$i UBfr4000}  { Procedure devant resider avant l'adresse &4000 }
{$i UKbd}      { Gestion du clavier }
{$i UMouse}    { Gestion de la souris }
{$i UGraph}    { Procedure graphiques }
{$i UMinFnt}   { Police proportionelle vectorielle }
{$i UScreen}   { Gestion des elements visuels }
{$i UPopUp}    { Gestion des fenetres entrees-sortie }
{$i UGeom}     { Trace de droite rapide }
{$i UElvis}    { Elements viseuls de TP Sprite }
{$i UEdtSpr}   { Edition d'une image de sprite }

Type TStr80=String[80];

Var l,c,i,j,k : Byte;
    Err:Integer;
    VFile:Text;
    ScrPal:TScrPal;

 Procedure EdtDta(nDir:TDirection); { Edition des donnees des Elvis }
   Begin
     Dir:=nDir;
     Case ElvSelect Of
       cElvSprites: EdtDtaSprites;
       cElvPal    : EdtDtaPal;
       cElvVert   : EdtDtaVrb(cElvVert);
       cElvRouge  : EdtDtaVrb(cElvRouge);
       cElvBleu   : EdtDtaVrb(cElvBleu);
       cElvZoomX  : EdtDtaZoom(ElvZoomX);
       cElvZoomY  : EdtDtaZoom(ElvZoomY);
       cElvBord   : EdtDtaBord;
       cElvVisu   : EdtDtaVisu;
       cElvBigSprL: EdtDtaBigSpr(ElvBigSprL);
       cElvBigSprH: EdtDtaBigSpr(ElvBigSprH);
       cElvMAnim  : EdtDtaMAnim;
       cElvVAnim  : EdtDtaVAnim;
     End;
   End;

  Procedure MouseSelect(Temp:TElv);
    Var NewElvSelect : TLElv;
        InRec:Boolean;
    Begin
      With Temp Do Begin
        InRec:= MouseInRec(x1+dx,199-y1 Div 2,x1+x2,199-(y1-y2) div 2);
        If InRec Then Begin
          NewElvSelect:=TLElv(Token);
          If NewElvSelect<>ElvSelect Then Begin
            ElvSelect:=NewElvSelect;
          End Else Begin
             EdtDta(DirMouse);
          End;
        End;
      End;
    End;

  {$i Uio }


{========================================================}
 Begin { Prog principal }

  If ParamCount=0 Then ElvNom.Nom:='Help'
                  Else ElvNom.Nom:=ParamStr(1);

  If ElvNom.Nom='Help' Then Begin
    Help1; Help2; ElvNom.Nom:='Default.spr';
  End;

  LoadSprite(ElvNom.Nom);
  Initialisation;

  Repeat
   Repeat

    GetMousePos; Cara:=GetChr;

    If Cara='X' Then Begin { Clic souris }

      MouseSelect(ElvPal.Aff);
      MouseSelect(ElvVrb[cElvVert].Aff);
      MouseSelect(ElvVrb[cElvRouge].Aff);
      MouseSelect(ElvVrb[cElvBleu].Aff);
      MouseSelect(ElvZoomX.Aff);
      MouseSelect(ElvZoomY.Aff);
      MouseSelect(ElvBord.Aff);
      MouseSelect(ElvVisu.Aff);
      MouseSelect(ElvBigSprL.Aff);
      MouseSelect(ElvBigSprH.Aff);
      MouseSelect(ElvMAnim.Aff);
      MouseSelect(ElvVAnim.Aff);
      If MouseInRec(0,0,12+ElvBigSprL.Taille*8*16,4+398-ElvBigSprH.Taille*4*16) Then Begin
        ElvSelect:=cElvSprites; EdtDta(DirMouse);
      End;
      ElvActuel;

    End Else Begin { Clavier }

      Case Cara Of

        { Deplacement dans le menu }
        CtrlRightArrow, CtrlDownArrow: ElvSuivant;
        CtrlLeftArrow, CtrlUpArrow   : ElvPrecedent;

        { Changement de valeur d'un elvis }
        RightArrow: EdtDta(Droite);
        LeftArrow : EdtDta(Gauche);
        UpArrow   : EdtDta(Haut);
        DownArrow : EdtDta(Bas);

        { Deplacement du sprite }
        ShiftRightArrow: MovRelBigSpr(1, 8, 0);
        ShiftLeftArrow : MovRelBigSpr(1,-8, 0);
        ShiftUpArrow   : MovRelBigSpr(1, 0, 4);
        ShiftDownArrow : MovRelBigSpr(1, 0,-4);

        #19 : If PopUpOK('Sauvegarde '+ElvNom.Nom,50) Then SaveSprite;

      End;
    End;

   Until Cara=KeyEsc;
  Until PopUpOK('Quitter TPSprite?',40);

  Delay(300);
  If PopUpOK('Sauvegarder le sprite?',45) Then SaveSprite;

  HidAllSpr; RazKbdBuf;
  SetMod(2);GotoXY(1,1);SetTxtPen(1);

  WriteLN('RAM dispo avant Dispose : ', MemAvail);

 { Raz pointeurs images sprites }
  For i:=1 To ElvBigSprL.Taille*ElvBigSprH.Taille Do
    For j:=1 To ElvMAnim.mCycle Do  Dispose(ElvSprites.BmpSpr[i,j]);

  { Raz ancienne copie }
  If SizCopie>2  Then Begin
    FreeMem(SprCopie,SizCopie);
    SizCopie:=0;
   End;

  WriteLN('RAM dispo apres Dispose : ', MemAvail);

End.

