{ ========================================================================
  TP-TOOLS v0.3 pour Turbo Pascal CPC+/CPM+. !!Uniquement pour CPC Plus!!
  Unite UAsic. Gestion de l'ASIC du CPC+              v0.3 By Nemo (2021)
 -------------------------------------------------------------------------}
Type
 { Decription de la structure memoire de l'ASIC }
 TSpr   = Array[0..$f, 0..$f] Of Byte;
 TScrPal= Array[0..$f] Of Integer; { SCReen PALette }
 TSprPal= Array[1..$f] Of Integer; { SPRite PALette. 0-> Transparence }
 TxySpr = Record x,y : Integer End;
 TSprPos= Record xy  : TxySpr; z: Byte; Bazar: Array[1..3] Of Byte End;
 TBigSpr= Record Lrg, Htr, LxH, z: Byte End;

Const
  Zy1=1; Zy2=2; Zy4=3;Zx1=4; Zx2=8; Zx4=12; { Zooms x et y }

Var
 TbSpr    : Array[0..15] Of TSpr    Absolute $4000; { Les 16 sprites hard }
 TbSprPos : Array[0..15] Of TSprPos Absolute $6000; { Position des 16 sprites }
 TbScrPal : TScrPal                 Absolute $6400; { Palette 16 couleurs ecran }
 ColBdr   : Integer                 Absolute $6420; { Couleur du bord }
 TbSprPal : TSprPal                 Absolute $6422; { Palette 15 coulleurs sprites }
 RstIntLin: Byte                    Absolute $6800; { Raster Interrupt Line}
 SplScrLin: Byte                    Absolute $6801; { Split Screen Line }
 SplScrAdr: Integer                 Absolute $6802; { Split Screen sec. Addr.}

 TbBigSpr: Array[0..15] Of TBigSpr; { Big sprites }
 iSpr,jSpr : Byte;

Procedure DlkAsic; { Delock ASIC }
 Type TCode = Array[1..17] Of Byte;
 Const Code:TCode=($ff,$00,$ff,$77,$b3,$51,$a8,$d4,$62,$39,$9c,$46,$2b,$15,$8a,$cd,$ee);
 Begin For iSpr:=1 To 17 Do Port[$bc00]:=Code[iSpr]; End;

Procedure OpnAsic; Begin Port[$7f00]:=$b8 End;

Procedure CloAsic; Begin Port[$7f00]:=$a0 End;

Procedure SetAsicPalMod1(a,b,c,d:Integer);
 Begin
   OpnAsic;
     TbScrPal[0]:=a;TbScrPal[1]:=b;TbScrPal[2]:=c;TbScrPal[3]:=d;
   CloAsic;
 End;

Procedure HidAllSpr;
 Begin  OpnAsic; For iSpr:=0 To 15 Do TbSprPos[iSpr].z:=0; CloAsic; End;

Procedure SetBigSpr(nr,a,b,zoom: Byte);
 Begin
   OpnAsic;
     With TbBigSpr[nr] Do Begin Lrg:=a; Htr:=b; LxH:=a*b; z:=Zoom End;
     For iSpr:=nr To a*b+nr-1 Do TbSprPos[iSpr].z:=zoom;
   CloAsic;
 End;

 Procedure SetZoomBigSpr(Spr,Zoom:Byte);
  Var n:Byte;
  Begin
   OpnAsic;
    For n:=Spr To TbBigSpr[Spr].LxH Do TbSprPos[n].z:=Zoom;
   CloAsic;
  End;

Procedure MovAbsBigSpr(n:Byte; xBig, yBig: Integer);
 Var Largeur,ZoomX,ZoomY:Byte;
 Begin
   OpnAsic;
     Largeur:=TbBigSpr[n].Lrg;
     Case TbBigSpr[n].z Of
        5 : Begin ZoomY:=16; ZoomX:=16; End;
        9 : Begin ZoomY:=16; ZoomX:=32; End;
        13: Begin ZoomY:=16; ZoomX:=64; End;
        6 : Begin ZoomY:=32; ZoomX:=16; End;
        10: Begin ZoomY:=32; ZoomX:=32; End;
        14: Begin ZoomY:=32; ZoomX:=64; End;
        7 : Begin ZoomY:=64; ZoomX:=16; End;
        11: Begin ZoomY:=64; ZoomX:=32; End;
        15: Begin ZoomY:=64; ZoomX:=64; End;
     End;

     For iSpr:=0 To (TbBigSpr[n].LxH)-1 Do Begin
       With TbSprPos[n+iSpr] Do Begin
         xy.x:=xBig+(iSpr Mod Largeur)*ZoomX;
         xy.y:=yBig+(iSpr Div Largeur)*ZoomY;
       End;
     End;
   CloAsic;
 End;

Procedure MovRelBigSpr(n:Byte; DeltaX, DeltaY: Integer);
 Begin
  OpnAsic;
   For iSpr:=0 To TbBigSpr[n].LxH-1 Do Begin
    With TbSprPos[n+iSpr] Do Begin
     xy.x:=xy.x+DeltaX;
     xy.y:=xy.y+DeltaY;
    End;
   End;
  CloAsic;
 End;

 Procedure SetPal4096;
  Begin OpnAsic; Inline($21/$b7f9/$cd/$fc5a/$bcdd); CloAsic; End;

 Function GetScrNumPal(n:Byte):Integer;
  Begin OpnAsic; GetScrNumPal:=TbScrPal[n]; CloAsic; End;

 Procedure SetPalBdr(n:Integer);
  Begin OpnAsic; ColBdr:=n; CloAsic; End;

 Procedure CpySprToAsic(Src:TSpr; Dst:Byte);
  Begin OpnAsic; TbSpr[Dst]:=Src; CloAsic; End;

 Procedure SetZoomSpr(Spr,Zoom:Byte);
  Begin OpnAsic; TbSprPos[Spr].z:=Zoom; CloAsic; End;

 Procedure MovSpr(Spr:Byte; xs,ys: Integer);
  Begin
    OpnAsic;
      TbSprPos[Spr].xy.x:=xs; TbSprPos[Spr].xy.y:=ys;
    CloAsic;
  End;

 Procedure SetScrInkPal(n:Byte; c:Integer);
   Begin OpnAsic; TbScrPal[n]:=c; CloAsic; End;

 Procedure GetScrPal( Var Pal:TScrPal);
   Var Temp:TScrPal;
   Begin
    OpnAsic; Temp:=TbScrPal; CloAsic;
    Pal:=Temp;
   End;

 Procedure GetSprPal( Var Pal:TSprPal);
  Var Temp:TSprPal;
  Begin
   OpnAsic; Temp:=TbSprPal; CloAsic;
   Pal:=Temp;
  End;

 Procedure SetSprPal(Pal:TSprPal);
   Begin OpnAsic; TbSprPal:=Pal; CloAsic; End;

 Procedure CpyScrPalToSpr;
  Begin
   OpnAsic;
    Move(TbScrPal[1], TbSprPal[1],30);
   CloAsic;
  End;

 Procedure CpySprPalToScr;
  Begin
   OpnAsic;
    Move(TbSprPal[1], TbScrPal[1],30);
   CloAsic;
  End;

Procedure SetSprPxl(n,x,y,e:Byte);
 Begin OpnAsic; TbSpr[n][x,y]:=e; CloAsic; End;

Procedure SetBigSprPxl(n,x,y,e:Byte);
 Var ns,xs,ys : Integer;
 Begin
   OpnAsic;
     ns:= 1 + x Div 16 * TbBigSpr[1].Lrg + (y Div 16) ;
     xs:=x Mod 16;
     ys:=y Mod 16;
     TbSpr[ns,xs,ys]:=e;
   CloAsic;
 End;

Function GetSprPxl(n,x,y:Byte):Byte;
 Var e:Byte;
 Begin OpnAsic; e:=TbSpr[n][x,y]; CloAsic; GetSprPxl:=e; End;

Procedure GetSprPos(n:Byte; Var x,y:Integer);
 Begin
   OpnAsic;
     x:=TbSprPos[n].xy.x;
     y:=TbSprPos[n].xy.y;
   CloAsic;
 End;

Function GetBigSprPxl(n,x,y:Byte):Byte;
 Var ns,xs,ys : Integer;
  Begin
   OpnAsic;
     ns:= 1 + x Div 16 * TbBigSpr[1].Lrg + (y Div 16) ;
     xs:=x Mod 16;
     ys:=y Mod 16;
     GetBigSprPxl:=TbSpr[ns,xs,ys];
   CloAsic;
 End;
