{---------------------------------------------------
  Procedure utilisant l'ASIC et devant s'executer
  avant l'adresse $4000
 ---------------------------------------------------}

Type

  TLElv=(cElvSprites,cElvPal,cElvRouge,cElvVert,cElvBleu,
         cElvZoomX, cElvZoomY, cElvBord, cElvVisu ,cElvMAnim,
         cElvVAnim, cElvBigSprL, cElvBigSprH, cNull);

  TVrb=$000..$fff; { Vert 0->&f, Rouge 0->$f, Bleu 0->$f }
  TNumPal=0..15;

Const
  { Codes Sprites }
  SprCurseur=10; SprPastille=11; SprVert=12; SprRouge=13; SprBleu=14;
  SprMarque=15;

Var
  Zoom: Byte;

{ Curseur edition des sprites }

Procedure GetCurXY(Var xc,yc:Integer);
 Var Temp:TxySpr;
 Begin
   OpnAsic;
    Temp:=TbSprPos[SprCurseur].xy;
   CloAsic;
   xc:=Temp.x; yc:=Temp.y;
 End;

Procedure SetCurColLig(Col,Lig:Byte);
Begin
  OpnAsic;
    TbSprPos[SprCurseur].xy.x:=8*Col+6;
    TbSprPos[SprCurseur].xy.y:=4*Lig+3;
  CloAsic;
End;

Procedure GetCurColLig(Var Col, Lig:Byte);
  Var xc,yc:Integer;
  Begin
     GetCurXY(xc,yc);
     Col:=(xc-6) Div 8; Lig:=(yc-3) Div 4;
   End;

Procedure MovCurColLig(Dx,Dy:Integer);
Begin
  OpnAsic;
    With TbSprPos[SprCurseur].xy Do Begin
      x:=x+8*Dx;
      y:=y+4*Dy;
    End;
  CloAsic;
End;

Procedure SetCurFromMouse(xm,ym:Integer);
Begin
  OpnAsic;
    With TbSprPos[SprCurseur].xy Do Begin
      x:=6+((xm Div 8)-1)*8;
      y:=3+((ym div 4)-1)*4;
    End;
  CloAsic;
End;

{--------------------------------------}
Procedure InitAsic;
 Var a,i,j,n:Byte;
 Begin
  DlkAsic; SetPal4096;
  OpnAsic;

    { Efface les sprites hard 10 a 15 }
    FillChar(TbSpr[10],6*$ff,0);

    { Curseur de selection d'un pixel sprite : Sprite 10 }
    For i:=0 To 5 Do
      For j:=0 To 5 Do Begin
        If ((i<1) Or (i>4)) Or ((j<1) Or (j>4)) Then
         If Odd(i+j) Then TbSpr[SprCurseur][i,j]:=$f Else TbSpr[SprCurseur][i,j]:=1;
      End;
    TbSprPos[SprCurseur].z:=0;

    { Pastille de selection : Sprite 11 }
    For i:=0 To 5 Do
      For j:=0 To 2 Do
        If Not(((i=0) Or (i=5)) And ((j=0) Or (j=2))) Then TbSpr[SprPastille][j,i]:=$f;
    TbSprPos[SprPastille].z:=Zx1 Or Zy1;

   { Curseurs vert-rouge-bleu 12 13 14}
    For n:=12 To 14 Do Begin
      For i:=0 To 8 Do
        For j:=0 To 6 Do
          If (i=0) Or (i=8) Or (j=0) Or (j=6) Then TbSpr[n][i,j]:=$1
                                              Else TbSpr[n][i,j]:=$f;
      TbSprPos[n].z:=Zx2 Or Zy1;
      TbSprPos[n].xy.x:=100;
      TbSprPos[n].xy.y:=600;
    End;

    { Curseur de 'marquage'  d'un pixel sprite : Sprite 15 }
    For i:=0 To 5 Do
      For j:=0 To 5 Do Begin
        If ((i<2) And (j<2)) Or ((i<2) And (j>3)) Or
           ((i>3) And (j<2)) Or ((i>3) And (j>3)) Then
         If Odd(i+j) Then TbSpr[SprMarque][i,j]:=$f
                     Else TbSpr[SprMarque][i,j]:=$1;
      End;
    TbSprPos[SprMarque].z:=0;

  CloAsic;
 End;

Procedure DspPastille(xPastille,yPastille:Integer);
  Begin
    OpnAsic;
     TbSprPos[SprPastille].xy.x:=xPastille;
     TbSprPos[SprPastille].xy.y:=yPastille;
    CloAsic;
  End;

 Procedure DspVrb(c:Byte;xVrb,yVrb,Intensite:Integer);
  Begin
   OpnAsic;
     TbSprPos[c].xy.x:=xVrb+12*Intensite;
     TbSprPos[c].xy.y:=yVrb;
    CloAsic;
  End;
