{ ---------------------------------------------
  Definition et affichage des ELements Visuels
  ---------------------------------------------}

  Type TDirection = (Aucune, Droite, Gauche, Haut, Bas, DirMouse);

  TElvSprites=Record
    Aff    : TElv;
    BmpSpr : Array[1..9, 1..6] Of ^TSpr; { Maxi:9 sprites assembles avec 6 anims }
    Zoom   : Byte;
    xyCur  : TxySpr;
   End;

  TElvPal=Record
    Aff    : TElv;
    Pal    : TScrPal;
    NumPal : TNumPal;
  End;

  TElvVrb=Array[cElvRouge..cElvBleu] Of Record
    Aff : TElv;
    Vrb : TVrb;
  End;

  TElvNom  = Record Aff: TElv; Nom: TStr14; End;
  TElvZoom = Record Aff: TElv; Zoom: Byte; End;
  TElvBord = Record Aff: TElv; On: Boolean; End;
  TElvVisu = Record Aff: TElv; On: Boolean; End;
  TElvBigSpr=Record Aff: TElv; Taille: Integer; End;
  TElvMAnim =Record Aff: TElv; mCycle: Byte; End;
  TElvVAnim =Record Aff: TElv; vCycle: Byte; End;


 Var
    ElvSelect  : TLElv;
    ElvSprites : TElvSprites;
    ElvPal     : TElvPal;
    ElvVrb     : TElvVrb;
    ElvNom     : TElvNom;
    ElvZoomX,
    ElvZoomY   : TElvZoom;
    ElvBord    : TElvBord;
    ElvVisu    : TElvVisu;
    ElvBigSprL,
    ElvBigSprH : TElvBigSpr;
    ElvMAnim   : TElvMAnim;
    ElvVAnim   : TElvVAnim;

    Dir : TDirection;

   BmpSprPush : Array[1..9] Of ^Tspr;

  { Var pour Copier-Coller }
    SprCopie: ^TBytes; { 'Bloc-note' }
    SizCopie: Integer; { Taille du bloc note }

    a,b,e,n,Stylo,Mask, LigM, ColM, NumImg :Byte;
    xs,ys,Src,Dst,Palette,ProfRecursion :Integer;
    cc,Cara:Char;

 Procedure DrwPxl;
  Var Lmod16,Cmod16 : Byte;
      Adr:Integer;
  Begin
    If (col in [0..ElvBigSprL.Taille*16-1]) And (lig in [0..ElvBigSprH.Taille*16-1]) Then Begin
      n:=1+Col Div 16+(Lig Div 16)*ElvBigSprL.Taille;
      Lmod16:=Lig Mod 16; Cmod16:=Col Mod 16;
      ElvSprites.BmpSpr[n,NumImg]^[Lmod16,Cmod16]:=c;
      SetSprPxl(n,Lmod16,Cmod16,c);
      GetPntAdr(2*Col+2,195-Lig*4,Adr,Mask);
      DrwFldBox(EncInk(TColor(c)),Adr,1,4);
    End;
  End;

 Procedure AfficheCadre;
   Var i,j:Byte;
   Begin
    { Affiche cadre du sprite et ses coches }
    SetGraPen(0);
    MovAbs(4,392);DrwRecRel(ElvBigSprL.Taille*128+4,-128*ElvBigSprH.Taille-2);
    SetGraPen(15);
    MovAbs(4,392);DrwRecRel(ElvBigSprL.Taille*128+4,-128*ElvBigSprH.Taille-2);
    For i:=1 To ElvBigSprH.Taille Do Begin
      For j:=1 To 4 Do Begin
        DrwPntAbs(2,394-128*(i-1)-32*j);
        DrwPntAbs(12+ElvBigSprL.Taille*128,394-128*(i-1)-32*j);
      End;
    End;
    For i:=1 To ElvBigSprL.Taille Do Begin { coche tous les 4 pixels }
      For j:=1 To 4 Do Begin
        DrwPntAbs(4+128*(i-1)+32*j,394);
        DrwPntAbs(4+128*(i-1)+32*j,388-ElvBigSprH.Taille*128);
      End;
    End;
  End;

 Procedure DisposeSprite;
   Var Mask,i,l: Byte;
       Adr : Integer;
   Begin
     GetPntAdr(0,199,Adr,Mask);
     DrwFldBox(EncInk(TColor(0)),Adr,50,199);
     l:=ElvBigSprL.Taille*ElvBigSprH.Taille;
     For n:=1 To l Do Begin
        FillChar(ElvSprites.BmpSpr[n,NumImg]^[0,0], 256, 0);
        CpySprToAsic(ElvSprites.BmpSpr[n,1]^,n);
        For i:=1 To ElvMAnim.mCycle Do
          Dispose(ElvSprites.BmpSpr[n,i]);
     End;
    End;

 Procedure NewSprite;
   Var i,n:Byte;
   Begin
     For n:=1 To ElvBigSprL.Taille*ElvBigSprH.Taille Do Begin
       For i:=1 To ElvMAnim.mCycle Do
         New(ElvSprites.BmpSpr[n,i]);
       FillChar(ElvSprites.BmpSpr[n,1]^[0,0],256,0);
       CpySprToAsic(ElvSprites.BmpSpr[n,1]^,n);
     End;
     AfficheCadre;
    End;

Procedure Push; { Sauve etat pour permettre annulation }
  Begin
  End;

Procedure Pop; { Annule commande si possible }
  Begin
  End;

{===================================================
  Chaque Elvis utilise 3 procedures :
    - DspEvlXxx : Affichage commun (cadre, nom...)
    - DspDtaXxx : Affichage des donnees specifiques
    - EdtEvlXxx : Edition des donnees
 ---------------------------------------------------}

 Procedure DspElv(Var Elv:TElv); { Affichage commun aux Elvis }
   Begin
     With Elv Do Begin SetGraPen($f);MovAbs(x1,y1); DspVecStr(Nom); End;
   End;


{-------------------- Bloc VRB ---------------------}

 Procedure DspElvVrb;
   Var c:TLElv;
   Begin
     For c:=cElvRouge To cElvBleu Do Begin
       DspElv(ElvVrb[c].Aff);
       With ElvVrb[c].Aff Do Begin
         MovAbs(x1+24,y1-10);DrwLinRel(180,0);
       End;
     End;
   End;

 Procedure DspDtaVrb;
  Var c:TLElv; n:TNumPal;
  Begin
    n:=ElvPal.NumPal;
    For c:=cElvRouge To cElvBleu Do Begin
     With ElvVrb[c].Aff Do Begin
       Case c Of
         cElvRouge: DspVrb(SprRouge,x1+22,200-(y1 Div 2),(GetScrNumPal(n) And $0f0) Div $10);
         cElvVert : DspVrb(SprVert, x1+22,200-(y1 Div 2),(GetScrNumPal(n) And $f00) Div $100);
         cElvBleu : DspVrb(SprBleu ,x1+22,200-(y1 Div 2),(GetScrNumPal(n) And $00f));
       End;
       SetGraPen($f); MovAbs(x1+24,y1-10); DrwLinRel(186,0);
     End;
    End;
  End;

Procedure EdtDtaVrb(Couleur:TLElv);
  Var
    v,r,b,n: Byte;
    NewC,Xm,Ym:Integer;
  Begin
    n:=ElvPal.NumPal;
    NewC:=ElvPal.Pal[n];
    v:=NewC Div $100; r:=(NewC Div $10) Mod $10; b:=NewC Mod $10;
    Case Dir Of
      DirMouse : Begin
                   GetMouseXY(Xm,Ym);
                   With ElvVrb[Couleur].Aff Do Begin
                     NewC:=(16*(Xm-x1-22)) Div (x2-22);
                     If NewC<0  Then NewC:=0;
                     If NewC>15 Then NewC:=15;
                     Case Couleur Of
                        cElvVert: v:=NewC;
                        cElvRouge:r:=NewC;
                        cElvBleu: b:=NewC;
                     End;
                   End;
                 End;
      Droite :
        Case Couleur Of
          cElvVert: v:=(v+1) Mod 16;
          cElvRouge:r:=(r+1) Mod 16;
          cElvBleu: b:=(b+1) Mod 16;
        End;
      Gauche :
        Case Couleur Of
          cElvVert: Begin v:=(v-1); If v=255 Then v:=15; End; { Byte ! }
          cElvRouge:Begin r:=(r-1); If r=255 Then r:=15; End;
          cElvBleu: Begin b:=(b-1); If b=255 Then b:=15; End;
        End;
    End;

    NewC:=v*$100+r*$10+b;
    ElvPal.Pal[n]:=NewC;
    SetScrInkPal(n,NewC);

    If ElvBord.On Then SetPalBdr(ElvPal.Pal[ElvPal.NumPal])
                  Else SetPalBdr($bbb);

    With ElvVrb[Couleur].Aff Do Begin
      MovAbs(x1,y1);
      Case Couleur Of
        cElvVert : DspVrb(SprVert, x1+22,200-(y1 Div 2),v);
        cElvRouge: DspVrb(SprRouge,x1+22,200-(y1 Div 2),r);
        cElvBleu : DspVrb(SprBleu ,x1+22,200-(y1 Div 2),b);
      End;
    End;
    CpyScrPalToSpr;
  End;

{---------------- Bloc Palette -----------------}

 Procedure DspElvPal;
   Begin DspElv(ElvPal.Aff) End;

 Procedure DspDtaPal;
   Var Msk, Ligne, Colonne:Byte;
   Begin
     With ElvPal.Aff Do Begin
       For Stylo:=0 To $f Do Begin
         MovAbs(x1+60+(Stylo Mod 8)*20,y1-16-(Stylo Div 8)*18);
         SetGraPen(Stylo);  DrwLinRel(12,0);
         If ElvPal.NumPal=Stylo Then SetGraPen(15) Else SetGraPen(0);
         MovAbs(x1+60+(Stylo Mod 8)*20,y1-20-(Stylo Div 8)*18);
         DrwLinRel(12,0);
       End;
       For Ligne:=0 To 1 Do Begin
         GetPntAdr(x1 Div 4+15,(y1-16) Div 2 -Ligne*9,Src,Msk);
         Dst:=Src;
         For a:=1 To 5 Do Begin
           Dst:=GetPrvLin(Dst);
           CpyBnk0v0(Src,Dst,20);
         End;
       End;
       SetGraPen($f); DrwPntAbs(x1+66,y1-10);
     End;
   End;

  Procedure EdtDtaPal;
    Var n:Byte;
        xm,ym : Integer;
                                                                                    Begin
      n:=ElvPal.NumPal;
      { Efface ancien Choix Couleur }
      With ElvPal.Aff Do Begin MovAbs(x1+60+(n Mod 8)*20,y1-20-(n Div 8)*18);
        SetGraPen(0);  DrwLinRel(12,0); SetGraPen(15);
        Case Dir Of
          DirMouse : Begin
                       GetMouseXY(Xm,Ym);
                       n:=(Xm-(x1+60-4)) Div 20;
                       If Ym>(((399-(y1-y2)) Div 2)-6) Then n:=n+8;
                     End;
          Droite   : Begin n:=n+1; If n>15 Then n:=0;  End;
          Gauche   : Begin n:=n-1; If n>15 Then n:=15; End; { ! Byte! }
          Haut,Bas : n:=(n+8) Mod 16;
        End;
      End;

      ElvPal.NumPal:=n; DspElvVrb;
      If ElvBord.On Then SetPalBdr(ElvPal.Pal[n]) Else SetPalBdr($bbb);

      { AfficheChoixCouleur }
       With ElvPal.Aff Do MovAbs(x1+60+(n Mod 8)*20,y1-20-(n Div 8)*18);
       SetGraPen(15);  DrwLinRel(12,0);
       DspDtaVrb;
       CpyScrPalToSpr;
    End;

{--------------------- Bloc Nom --------------------}

 Procedure DspElvNom; Begin DspElv(ElvNom.Aff) End;

 Procedure DspDtaNom;
   Begin
     MovAbs(ElvNom.Aff.x1,ElvNom.Aff.y1);
     DspVecStr(ElvNom.Nom);
   End;

 {---------------- Bloc Visu Sprite ----------------}

 Procedure DspElvVisu;
   Begin DspElv(ElvVisu.Aff);End;

 Procedure DspDtaVisu;
   Begin
     With ElvVisu Do Begin
       MovAbs(Aff.x1+92,Aff.y1);
       If On Then DspVecStr('}') Else DspVecStr('{') ;
     End;
      If ElvVisu.On Then Begin
        SetBigSpr(1,ElvBigSprL.Taille,ElvBigSprH.Taille,4*ElvZoomX.Zoom+ElvZoomY.Zoom);
        MovAbsBigSpr(1,420,90);
      End Else Begin
        SetZoomBigSpr(1,0);
      End;
   End;

  Procedure EdtDtaVisu;
    Begin
      SetGraPen(0); DspDtaVisu;
      ElvVisu.On:=Not(ElvVisu.On);
      SetGraPen(15); DspDtaVisu;
    End;

{--------------- Bloc Zoom -------------------}

 Procedure DspDtaZoom(Var ElvZoom:TElvZoom);
   Begin
     With ElvZoom.Aff Do Begin
       MovAbs(x1+20,y1);
       If (ElvZoom.Aff.Token=Ord(cElvZoomX)) Then MovRel(84,0);
       DspVecStr(Chr(ElvZoom.Zoom+48));
     End;
   End;

  Procedure EdtDtaZoom(Var ElvZoom:TElvZoom);
    Begin
      SetGraPen(0); DspDtaZoom(ElvZoom);
      If Dir=DirMouse Then Dir:=Droite;
      With ElvZoom Do Begin
        Case Dir Of
          Droite : Begin Zoom:=Zoom+1; If Zoom>3 Then Zoom:=1; End;
          Gauche : Begin Zoom:=Zoom-1; If Zoom=0 Then Zoom:=3; End;
        End;
      End;
      SetGraPen(15); DspDtaZoom(ElvZoom);
      ElvVisu.On:=True; DspDtaVisu;
      SetBigSpr(1,ElvBigSprL.Taille, ElvBigSprH.Taille,4*ElvZoomX.Zoom+ElvZoomY.Zoom);
   End;

  Procedure DspElvZoom(Var ElvZoom : TElvZoom);
   Begin DspElv(ElvZoom.Aff) End;

{---------------- Bloc Animation Val --------------}

 Procedure DspElvVAnim;
    Begin DspElv(ElvVAnim.Aff) End;

 Procedure DspDtaVAnim;
   Begin
      With ElvVAnim.Aff Do Begin
        MovAbs(x1+64,y1); DspVecStr(Chr(ElvVAnim.vCycle+48));
        MovAbs(x1+92,y1); DspVecStr(Chr(NumImg+48));
      End;
    End;

 Procedure EdtDtaVAnim;
   Var i:Byte;
   Begin
     SetGraPen(0); DspDtaVAnim;
     If Dir=DirMouse Then Dir:=Droite;
     With ElvVAnim Do Begin
       Case Dir Of
         Droite : Begin vCycle:=vCycle+1; If vCycle>ElvMAnim.mCycle Then vCycle:=1 End;
         Gauche : Begin vCycle:=vCycle-1; If vCycle=0 Then vCycle:=ElvMAnim.mCycle End;
       End;
     End;
     SetGraPen(15); DspDtaVAnim;

     For i:=1 To ElvBigSprL.Taille*ElvBigSprH.Taille Do
       CpySprToAsic(ElvSprites.BmpSpr[i,ElvVAnim.vCycle]^,i);
   End;


{---------------- Bloc Animation Max --------------}

Procedure DspElvMAnim;
   Begin DspElv(ElvMAnim.Aff) End;

Procedure DspDtaMAnim;
  Begin
     With ElvMAnim.Aff Do Begin
       MovAbs(x1+80,y1); DspVecStr(Chr(ElvMAnim.mCycle+48));
     End;
   End;

Procedure EdtDtaMAnim;
  Var AncienneValeur,i:Byte;
  Begin
    SetGraPen(0); DspDtaMAnim;
    If Dir=DirMouse Then Dir:=Droite;
    With ElvMAnim Do Begin
      AncienneValeur:=mCycle;
      Case Dir Of
        Droite : Begin mCycle:=mCycle+1; If mCycle>6 Then mCycle:=1; End;
        Gauche : Begin mCycle:=mCycle-1; If mCycle=0 Then mCycle:=6; End;
      End;

      If mCycle<AncienneValeur Then Begin
        If PopUpOk('R&duire le nombre d''animations?',65) Then Begin
          SetGraPen(0);DspDtaVAnim;
          ElvVAnim.vCycle:=1;
          SetGraPen(15);DspDtaVAnim;
          For i:=mCycle+1 To AncienneValeur  Do
            For n:=1 To ElvBigSprH.Taille*ElvBigSprL.Taille Do
              Dispose(ElvSprites.BmpSpr[n,i]);
        End Else Begin
          mCycle:=AncienneValeur
        End;
      End Else Begin
        If mCycle>AncienneVAleur Then
          For i:=AncienneValeur+1 To mCycle Do
            For n:=1 To ElvBigSprH.Taille*ElvBigSprL.Taille Do
              New(ElvSprites.BmpSpr[n,i]);
          If PopUpOK('Recopier image pr&c&dente?',55) Then
             For n:=1 To ElvBigSprH.Taille*ElvBigSprL.Taille Do
               ElvSprites.BmpSpr[n,i]^:=ElvSprites.BmpSpr[n,i-1]^;
      End;
    End;

    SetGraPen(15); DspDtaMAnim;
  End;

{---------------- Bloc Bordure --------------------}

 Procedure DspElvBord; Begin  DspElv(ElvBord.Aff); End;

 Procedure DspDtaBord;
   Begin
     With ElvBord Do Begin
       MovAbs(Aff.x1+80,Aff.y1);
       If On Then Begin
          DspVecStr('}'); SetPalBdr(ElvPal.Pal[ElvPal.NumPal]);
       End Else Begin
          DspVecStr('{'); SetPalBdr($bbb);
       End;
     End;
   End;

 Procedure EdtDtaBord;
   Begin
     SetGraPen(0); DspDtaBord;      { Efface }
     If Dir=DirMouse Then Dir:=Droite;
     ElvBord.On:=Not(ElvBord.On);
     SetGraPen(15); DspDtaBord;     { Affiche }
   End;

{---------------- Bloc Taille  -----------------}

 Procedure DspElvBigSpr(Var ElvBigSpr: TElvBigSpr);
   Begin DspElv(ElvBigSpr.Aff); End;

 Procedure DspDtaBigSpr(Var ElvBigSpr: TElvBigSpr);
   Begin
     With ElvBigSpr.Aff Do Begin
       If (ElvBigSpr.Aff.Token=Ord(cElvBigSprH))
         Then  MovAbs(x1+20,y1) Else MovAbs(x1+108,y1);
       DspVecStr(Chr(ElvBigSpr.Taille+48));
     End;
   End;

  Procedure EdtDtaBigSpr(Var ElvBigSpr: TElvBigSpr);
    Begin
      If Not(PopUpOK('Effacer le sprite?',35)) Then Exit;
      DisposeSprite;
      SetGraPen(0); DspDtaBigSpr(ElvBigSpr);
      With ElvBigSpr Do Begin
        Case Dir Of
          Droite : Begin Taille:=Taille+1; If Taille>3 Then Taille:=1; End;
          Gauche : Begin Taille:=Taille-1; If Taille=0 Then Taille:=3; End;
        End;
      End;
      NewSprite;
      SetGraPen(15); DspDtaBigSpr(ElvBigSpr); DspDtaVisu;
   End;

{---------------------------------------------------}
Procedure MovSelect(Var Elv:TElv);
  Begin
   With Elv Do Begin
    xs:=x1+dx;ys:=y1+dy;
   End;
  End;

Procedure Tab;
 Begin
  Case ElvSelect Of
   cElvSprites : MovSelect(ElvSprites.Aff);
   cElvPal     : MovSelect(ElvPal.Aff);
   cElvRouge   : MovSelect(ElvVrb[cElvRouge].Aff);
   cElvVert    : MovSelect(ElvVrb[cElvVert].Aff);
   cElvBleu    : MovSelect(ElvVrb[cElvBleu].Aff);
   cElvZoomX   : MovSelect(ElvZoomX.Aff);
   cElvZoomY   : MovSelect(ElvZoomY.Aff);
   cElvBord    : MovSelect(ElvBord.Aff);
   cElvVisu    : MovSelect(ElvVisu.Aff);
   cElvBigSprL : MovSelect(ElvBigSprL.Aff);
   cElvBigSprH : MovSelect(ElvBigSprH.Aff);
   cElvMAnim   : MovSelect(ElvManim.Aff);
   cElvVAnim   : MovSelect(ElvVAnim.Aff);
  End;
 End;

Procedure ElvActuel; Begin Tab; DspPastille(xs,199-(ys Div 2)); End;

Procedure ElvSuivant;
 Begin
   If ElvSelect=cElvBigSprH Then ElvSelect:=cElvSprites Else ElvSelect:=Succ(ElvSelect);
   ElvActuel;
 End;

Procedure ElvPrecedent;
 Begin
  If ElvSelect=cElvSprites Then ElvSelect:=cElvBigSprH Else ElvSelect:=Pred(ElvSelect);
  ElvActuel;
 End;

 Procedure EdtDtaNom; Begin End;


