{ =========================================================
   TP-TOOLS v 0.3 pour Turbo Pascal/CPM+/CPC6128
   UScreen : Unite blocs graphiques v0.3 by Nemo59 (2021)
  --------------------------------------------------------- }
Type
  TStr14= String[14];
  TBytes=Array[1..MaxInt] Of Byte; { Tableau virtuel d'octets de taille indefinie }

  TWin=Record { Fenetre graphique bitmap a l'octet pres en x }
    x,y:Integer;
    Larg,Haut:Byte;
    Size:Integer;
    Datas:^TBytes;
  End;

  TElv=Record { Elements visuels }
    Nom:TStr14;
    x1,y1,x2,y2:Integer;
    Dx,Dy:Integer; { Delta pour affichage pastille 'actif' par rapport a x1,y1 }
    Token : Byte;
  End;

  TPWin=^TWin;
  TScreen=Array[0..$3999] Of Byte;

Procedure CpyBnk1v0(Src,Dst,Siz:Integer);
 { Copie Zone memoire depuis bank 1 du cpm (TPA) vers bank 0 qui contient la video }
 Begin
  Inline($06/$00/$0e/$01/$cd/$fc57/$ed/$5b/Src/$2a/Dst/$ed/$4b/Siz/$cd/$fc4b);
 End;

Procedure CpyBnk0v1(Src,Dst,Siz:Integer);
 { Copie Zone memoire depuis bank 0 du cpm vers bank 1 }
 Begin
  Inline($06/$01/$0e/$00/$cd/$fc57/$ed/$5b/Src/$2a/Dst/$ed/$4b/Siz/$cd/$fc4b);
 End;

Procedure CpyBnk0v0(Src,Dst,Siz:Integer);
 { Copie Zone memoire bank 0 -> bank 0 }
 Begin
  Inline($06/$00/$0e/$00/$cd/$fc57/$ed/$5b/Src/$2a/Dst/$ed/$4b/Siz/$cd/$fc4b);
 End;

Function GetNxtLin(Adr:Integer):Integer; { Adresse video ligne suivante }
 Var NxtLin:Integer;
 Begin Inline($2a/Adr/$cd/$fc5a/$bc26/$22/NxtLin);GetNxtLin:=NxtLin; End;

Function GetPrvLin(Adr:Integer):Integer;
 Var PrvLin:Integer;
 Begin Inline($2a/Adr/$cd/$fc5a/$bc29/$22/PrvLin);GetPrvLin:=PrvLin; End;

Procedure SetElv(Var Elvis:TElv;
                  nNom:TStr14; nx1,ny1,nx2,ny2,ndx,ndy:Integer; nToken:Byte);
 Begin
  With Elvis Do Begin
    x1:=nx1; y1:=ny1; x2:=nx2; y2:=ny2; dx:=ndx; dy:=ndy;
    Nom:=nNom; Token:=nToken;
  End;
 End;

Procedure CpyWin(x1,y1,Larg,Haut,x2,y2:Integer);
 { Copie une zone rectangulaire (a l'octet pres) dans la memoire video }
 Var
   Src,Dst:Integer;
   Mask,h:Byte;
 Begin
   GetPntAdr(x1,y1,Src,Mask);
   GetPntAdr(x2,y2,Dst,Mask);
   For h:=1 To Haut Do Begin
     CpyBnk0v0(Src,Dst,Larg);
     Src:=GetNxtLin(Src);
     Dst:=GetNxtLin(Dst);
   End;
 End;

Function GetWin(xWin,yWin:Integer; LargWin,HautWin:Byte):TPWin;
 Var
   Win:TPWin;
   Src,Dst:Integer;
   Mask,h:Byte;
 Begin
   New(Win);
   With Win^ Do Begin
     x:=xWin; y:=yWin; Larg:=LargWin; Haut:=HautWin;
     Size:=LargWin*HautWin;
     GetMem(Datas,Size);
     GetPntAdr(xWin,yWin,Src,Mask);
     Dst:=Addr(Datas^);
     For h:=1 To HautWin Do Begin
       CpyBnk0v1(Src,Dst,LargWin);
       Src:=GetNxtLin(Src);
       Dst:=Dst+Larg;
     End;
   End;
   GetWin:=Win;
 End;

Procedure PutWin(x,y:Integer; Win:TPWin);
 { Copie image depuis un pointeur de la RAM/TPA vers ecran }
 Var Src,Dst:Integer;
     Mask,h:Byte;
 Begin
   GetPntAdr(x,y,Dst,Mask);
   With Win^ Do Begin
     Src:=Addr(Datas^);
     For h:=1 To Haut Do Begin
       CpyBnk1v0(Src,Dst,Larg);
       Src:=Src+Larg;
       Dst:=GetNxtLin(Dst);
     End;
   End;
 End;

Procedure PopWin(Win:TPWin);
 Begin
  PutWin(Win^.x,Win^.y,Win);
 End;

Procedure DisposeWin(Win:TPWin);
{ Libere la memoire utilisee par l'image en RAM }
 Begin
   FreeMem(Win^.Datas,Win^.Size);
   Dispose(Win);
 End;

Procedure LoadScr(Var Str:TStr14;OffSet:Integer);
 Var
   VFile:File;
   PScreen: ^TScreen;
 Begin
   New(PScreen);
   Assign(VFile,Str); Reset(VFile);
   BlockRead(VFile,PScreen^,128); Close(VFile);
   CpyBnk1v0(Addr(PScreen^)+OffSet,$4000,$4000);
   Dispose(PScreen);
 End;

Procedure SaveScr(Var Str:TStr14);
 Var
   VFile:File;
   PScreen: ^TScreen;
 Begin
   New(PScreen);
   Assign(VFile,Str); Rewrite(VFile);
   BlockWrite(VFile,PScreen^,128); Close(VFile);
   CpyBnk0v1($4000,Addr(PScreen^),$4000);
   Dispose(PScreen);
 End;
